viGroupManagerSlotOutput = {};

function viGroupManagerSlotOutput:load(slotTable)	
	local playerFarmId = g_currentMission.player.farmId;
	local lineTable = {line={}};
	local isLineTable = nil;
	local color = "txtOutputTitle";
	local iconColor = "white";
	--title--
	lineTable.line[#lineTable.line+1] = {};
	isLineTable = lineTable.line[#lineTable.line];	
	isLineTable.txt = {};
	isLineTable.txt[1] = {};
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].slotColor = color;					
	isLineTable.txt[1].txt = "VehicleInspector Groups";			
	isLineTable.txt[1].alignment = 2;	
	isLineTable.txt[1].callback = viGroupManagerSlotOutput.clickTitle;
	
	
	isLineTable.txt[1].icon = {before={},after={}};
	if not viGroupManager.profil.save then iconColor = "yellow";else iconColor = "green";end;
	isLineTable.txt[1].icon.before[1] = {name="buttonSave", color=iconColor, settingButton=true, callback={[1]=viGroupManagerSlotOutput.clickSaveGroups}};
	iconColor = "white";	
	if VehicleInspector.seeVehicle.isGroup then iconColor = "ls22";else iconColor = "darkGray";end;
	isLineTable.txt[1].icon.before[2] = {name="group", color=iconColor, modName="VehicleInspector", groupName="groupmanageroutput", callback={[1]=viGroupManagerSlotOutput.clickViewGroupLine}};
	iconColor = "white";
	if viGroupManagerSlot.values.viewVehicleIcon == 1 then iconColor = "darkGray";elseif viGroupManagerSlot.values.viewVehicleIcon == 2 then iconColor = "whiteInactive";end;
	isLineTable.txt[1].icon.before[3] = {name="viewVehicleIcon", color=iconColor, modName="VehicleInspector", groupName="groupmanageroutput", callback={[1]=viGroupManagerSlotOutput.clickViewVehicleIcon}};
	--title--
	local seperator = false;
	function setGroupSeperator(group)
		---group seperator---
		lineTable.line[#lineTable.line+1] = {};
		isLineTable = lineTable.line[#lineTable.line];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = "*".. tostring(viGroupManager.groupsName[group]).. "*";				
		isLineTable.txt[1].callback = viGroupManagerSlotOutput.clickGroupNumberOrName;
		isLineTable.txt[1].ownTable={group};
		---group seperator---
		setSeperator = false;
	end;	
	--groups lines--
	function getGroupColor(group)
		if viGroupManager:hasGroupVehicles(group) then
			if viGroupManager.viewGroups[group] then
				return "green";
			else
				return "white";
			end;
		else
			if viGroupManager.viewGroups[group] then
				return "orangeRed";				
			else
				return "darkGray";
			end;
		end;
	end;	
	if viGroupManagerSlot.values.viewGroupLine then
		local groupLine1 = {generate=true,width=10};
		local groupLine2 = {generate=viGroupManager.maxGroups > 10,width=100/10};	
		if viGroupManager.maxGroups > 10 then groupLine1.width = 100/10;else groupLine1.width = 100/viGroupManager.maxGroups;end;
		local vehicle = g_currentMission.controlledVehicle;
		local lineGroup = 0;
		for group=1, viGroupManager.maxGroups do 
			if groupLine1.generate then
				groupLine1.generate = false;
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];				
				isLineTable.txt = {};			
			elseif group > 10 and groupLine2.generate then
				groupLine2.generate = false;
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];				
				isLineTable.txt = {};
				lineGroup = 10;
			end;
			isLineTable.txt[group-lineGroup] = {};
			local moreTxt = "";
			if vehicle ~= nil and vehicle.viControl ~= nil and vehicle.viControl.group ~= nil and vehicle.viControl.group[group] ~= nil then moreTxt = "^";end;
			isLineTable.txt[group-lineGroup].bold = true;
			isLineTable.txt[group-lineGroup].color = getGroupColor(group);
			if group == 1 then 
				isLineTable.txt[group-lineGroup].txt = " ".. tostring(group).. tostring(moreTxt);
			else
				isLineTable.txt[group-lineGroup].txt = tostring(group).. tostring(moreTxt);
			end;
			--if group == 10 or group == 20 then isLineTable.txt[group-lineGroup].alignment = 1;
			--else isLineTable.txt[group-lineGroup].alignment = 2;end;
			if group <= 10 then	isLineTable.txt[group-lineGroup].width = groupLine1.width;else isLineTable.txt[group-lineGroup].width = groupLine2.width;end;
			isLineTable.txt[group-lineGroup].callback = viGroupManagerSlotOutput.clickGroupNumberOrName;
			isLineTable.txt[group-lineGroup].ownTable={group};
			setSeperator = true;
		end;		
		---seperator---
		lineTable.line[#lineTable.line+1] = {};
		isLineTable = lineTable.line[#lineTable.line];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = "----";		
		isLineTable.txt[2] = {};
		isLineTable.txt[2].slotColor = "txtOutputTitle";
		isLineTable.txt[2].bold = true;
		isLineTable.txt[2].txt = "----";
		isLineTable.txt[2].alignment = 3;				
		---seperator---	
	end;
	--groups lines--
	--view groups--
	function getVehicleName(vehicle)
		local storeName = tostring(vehicle.getName(vehicle));
		local vehicleName = tostring(vehicle.viVehicleName);
		if VehicleInspector.seeTxt.vehicleName == 2 or VehicleInspector.global.forceView > 0 then 
			vehicleName = tostring(storeName);		
		end;
		return vehicleName;
	end;	
	for group=1, viGroupManager.maxGroups do 
		if viGroupManager.viewGroups[group] then
			for groupTyp, value in pairs(viGroupManager.groups[group]) do
				if groupTyp ~= nil and value.node ~= nil and value.node > 0 and g_currentMission.vehicles ~= nil then
					local vehicle = g_currentMission.nodeToObject[value.node];
					if vehicle ~= nil then						
						if setSeperator then setGroupSeperator(group);end;
						color = "white";
						iconColor = "darkGray";
						local widthFix = 1.5;local heightFix = 1.5;
						if viGroupManagerSlot.values.viewVehicleIcon == 2 then widthFix = 1.3;heightFix = 1.3;end;
						local categoryName = vehicle.viCategoryName;
						local overlayName = tostring(vehicle.getName(vehicle));
						local iconName = categoryName;						
						if viGroupManagerSlot.values.viewVehicleIcon == 3 then
							if g_currentMission.multiOverlayV4.moSetGetOverlays.icons.byName["VehicleInspector"]["groupmanageroutput"][overlayName] ~= nil then iconName = overlayName;iconColor = nil;end;
						end;						
						local nextTxt = 1;
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];				
						isLineTable.txt = {};
						local isHelper = viSetGet:isHelper(vehicle);
						local isPlayer = vehicle.getIsControlled(vehicle);
						if isPlayer then color = "ls22";iconColor = "ls22";elseif isHelper then color = "green";iconColor = "green";end;
						isLineTable.txt[nextTxt] = {};
						--isLineTable.txt[nextTxt].bold = true;
						isLineTable.txt[nextTxt].color = color;
						local moreTxt = "";
						if viGroupManagerSlot.values.viewGroupTyp then moreTxt = " | ".. tostring(groupTyp);end;
						isLineTable.txt[nextTxt].txt = " ".. tostring(getVehicleName(vehicle)).. tostring(moreTxt);
						isLineTable.txt[nextTxt].width = 93;
						isLineTable.txt[nextTxt].callback = viGroupManagerSlotOutput.clickVehicle;
						isLineTable.txt[nextTxt].ownTable={value.node, group};
						if viGroupManagerSlot.values.viewVehicleIcon > 1 then
							isLineTable.txt[nextTxt].icon = {before={},after={},behindTxt={}};						
							isLineTable.txt[nextTxt].icon.before[1] = {name=tostring(iconName), color=iconColor, modName="VehicleInspector", groupName="groupmanageroutput", posFixY=true, widthFix=widthFix, heightFix=heightFix, callback={[1]=viGroupManagerSlotOutput.clickVehicle}, ownTable={value.node, group}};						
						end;
					end;					
				end;
			end;
			setSeperator = true;
		end;	
	end;
	--view groups--	
	--help icon--
	if slotTable ~= nil and slotTable.help.outputOn and lineTable.line[1] ~= nil and lineTable.line[1].txt ~= nil and lineTable.line[1].txt[1] ~= nil then		
		if lineTable.line[1].txt[1].icon == nil then lineTable.line[1].txt[1].icon = {before={},after={}};
			lineTable.line[1].txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=viGroupManagerSlotOutput.clickTitleHelpTxt}};
		else
			table.insert(lineTable.line[1].txt[1].icon.before, 1, {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=viGroupManagerSlotOutput.clickTitleHelpTxt}});
		end;
	end;
	--help icon--
	viGroupManagerSlotOutput.output = lineTable;
end;
	

function viGroupManagerSlotOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" then return false;end;
	g_currentMission.multiOverlayV4.moduleFunction.setActiveRunningModul( {modName="vehicleInspector", modulName="viGroupManagerSlot" } );	
	viGroupManagerSlotOutput:load(args.slotTable);
	return viGroupManagerSlotOutput.output;
end;

function viGroupManagerSlotOutput.clickTitleHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		g_currentMission.multiOverlayV4.moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		g_currentMission.multiOverlayV4.moSetGetOverlays.infoHelpBox.help.titel = "VehicleInspector GroupManager";
		g_currentMission.multiOverlayV4.moSetGetOverlays.infoHelpBox.help.txt = "Click Icons/Vehicles for interaction and ... (Mouse Click Left/Right/Middle)\nJoin/Teleport/Hotspot a Vehicle";
	end;
end;

function viGroupManagerSlotOutput.clickGroupNumberOrName(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			viGroupManager:setViewGroup(args.ownTable[1]);
			if viGroupManager:isViewGroup(args.ownTable[1]) and not viGroupManager:hasGroupVehicles(args.ownTable[1]) then
				g_currentMission.hl.addTextDisplay( {txt="GroupManager: ".. tostring(viGroupManager.groupsName[args.ownTable[1]]).. " ! is empty !", txtBold=true, warning=true, duration=3} );
			end;
			--viGroupManager:printGroup(args.ownTable[1])
		end;
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then
		if args.ownTable[1] ~= nil then
			if g_currentMission.controlledVehicle ~= nil then --and not VehicleInspector.global.groupLine.setting then
				viGroupManager:insertGroupVehicle(g_currentMission.controlledVehicle, args.ownTable[1], true);
			else
				g_currentMission.hl.addTextDisplay( {txt="GroupManager: ! Join first a Vehicle !", txtBold=true, warning=true, duration=4} );
			end;
		end;
	end;
end;	

function viGroupManagerSlotOutput.clickVehicle(args) --join vehicle
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			args.rootNode = args.ownTable[1];
			viSetGet:clickVehicleJoin(args);
		end;
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil then			
			local vehicle = g_currentMission.nodeToObject[args.ownTable[1]];
			if vehicle ~= nil then
				viGroupManager:insertGroupVehicle(vehicle, args.ownTable[2], true);				
			end;
		end;
	elseif args.mouseClick == "MOUSE_BUTTON_MIDDLE" and args.isDown then
		if args.ownTable[1] ~= nil then			
			local vehicle = g_currentMission.nodeToObject[args.ownTable[1]];
			if vehicle ~= nil then
				local x, _, z = getWorldTranslation(args.ownTable[1]);						
				if x ~= nil and x ~= 0 then					
					g_currentMission.multiOverlayV4.moSetGetOverlays:mapHotSpot({}, {x}, {z}, 1); --besser sichtbar
					--g_currentMission.multiOverlayV4.moSetGetOverlays:generateObjectsMapHotSpot( {args.ownTable[1]} )
				end;
			end;
		end;
	end;
end;

function viGroupManagerSlotOutput.clickSaveGroups(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		g_currentMission.hl.addTextDisplay( {txt="GroupManager: save Group Profil... (".. tostring(viGroupManager:getActiveProfil()).. ".xml)", txtBold=true, duration=3} );
		viGroupManagerXml:saveProfile(true);
	end;
end;	

function viGroupManagerSlotOutput.clickViewVehicleIcon(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if viGroupManagerSlot.values.viewVehicleIcon == 1 then 
			viGroupManagerSlot.values.viewVehicleIcon = 2;
		elseif viGroupManagerSlot.values.viewVehicleIcon == 2 then 
			viGroupManagerSlot.values.viewVehicleIcon = 3;
		else
			viGroupManagerSlot.values.viewVehicleIcon = 1;
		end;
		VehicleInspector.moh.MultiOverlayV4:setUnSave();
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then
		viGroupManagerSlot.values.viewGroupTyp = not viGroupManagerSlot.values.viewGroupTyp;
		VehicleInspector.moh.MultiOverlayV4:setUnSave();		
	end;
end;

function viGroupManagerSlotOutput.clickViewGroupLine(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then
		viGroupManagerSlot.values.viewGroupLine = not viGroupManagerSlot.values.viewGroupLine;
	elseif args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		VehicleInspector.seeVehicle.isGroup = not VehicleInspector.seeVehicle.isGroup;
		g_currentMission.hlGui.setGet:setUnSave();
		if VehicleInspector.seeVehicle.isGroup then
			g_currentMission.hl.addTextDisplay( {txt="View Vehicle *isGroup*", txtBold=true, duration=3} );													
		else
			g_currentMission.hl.addTextDisplay( {txt="View NOT Vehicle *isGroup*", txtBold=true, duration=3} );													
		end;
	end;
end;

function viGroupManagerSlotOutput.clickTitle(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		viSetGet:openCloseGuiMenue("GroupManagerSetting", "GroupManagerSetting")
	end;
end;

if g_currentMission.multiOverlayV4 ~= nil then
	g_currentMission.multiOverlayV4.moduleFunction.addActiveRunningModul( {modName="vehicleInspector", modulName="viGroupManagerSlot" } );
end;